# Copyright 2005, @Last Software, Inc.

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------

def alwaysFaceCameraEqualsTest

        model = Sketchup.active_model
        # Returns a DefintionList
        definitions = model.definitions
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        begin
            definition = definitions.load path
        rescue
            UI.messagebox $!.message
        end
        behavior = definition.behavior
        b = behavior.always_face_camera?
        if (b)
            UI.messagebox b
        else
           UI.messagebox "Always Face Camera is equal to false"
        end
        # Returns
        status = behavior.always_face_camera = true
        b = behavior.always_face_camera?
        if (b)
            UI.messagebox b
        else
            UI.messagebox "Failure"
        end
     
end


def alwaysFaceCameraTest

        model = Sketchup.active_model
        # Returns a DefintionList
        definitions = model.definitions
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        begin
            definition = definitions.load path
        rescue
            UI.messagebox $!.message
        end
        behavior = definition.behavior
        b = behavior.always_face_camera?
        if (b)
            UI.messagebox b
        else
           UI.messagebox "Always Face Camera is equal to false"
        end
        # Returns
        status = behavior.always_face_camera = true
        b = behavior.always_face_camera?
        if (b)
            UI.messagebox b
        else
            UI.messagebox "Failure"
        end
     
end

def cutsOpeningTest

        model = Sketchup.active_model
        # Returns a DefintionList
        definitions = model.definitions
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        begin
            definition = definitions.load path
        rescue
            UI.messagebox $!.message
        end
        behavior = definition.behavior
        b = behavior.cuts_opening?
        if (b)
            UI.messagebox b
        else
            UI.messagebox "Failure: Cuts Opening is False"
        end
        # Returns
        # I shouldn't be able to set cuts_opening to true on a component that doesn't have
        # A "glue to" setting.
        behavior.cuts_opening = true
        b = behavior.cuts_opening?
        if (b)
            UI.messagebox b
        else
            UI.messagebox "Failure"
        end
end

def is2dTest

        model = Sketchup.active_model
        # Returns a DefintionList
        definitions = model.definitions
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        begin
            definition = definitions.load path
        rescue
            UI.messagebox $!.message
        end
        behavior = definition.behavior
        b = behavior.is2d?
        if (b)
            UI.messagebox b
        else
            UI.messagebox "Failure: Is not a 2D Model"
        end
        begin
            behavior.is2d = true
        rescue
            UI.messagebox $!.message
        end
        b = behavior.is2d?
        if (b)
            UI.messagebox b
        else
            UI.messagebox "Failure"
        end
end

def shadowsFaceSunEqualsTest
        model = Sketchup.active_model
        # Returns a DefintionList
        definitions = model.definitions
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        begin
            definition = definitions.load path
        rescue
            UI.messagebox $!.message
        end
        behavior = definition.behavior
        b = behavior.always_face_camera?
        if (b)
            UI.messagebox b
        else
           UI.messagebox "Always Face Camera is equal to false"
        end
        # Returns
        status = behavior.always_face_camera = true
 
        behavior = behavior.shadows_face_sun= true
        if (behavior)
                UI.messagebox behavior
        else
                UI.messagebox "Failure"
        end

end

def shadowsFaceSunTest

        model = Sketchup.active_model
        # Returns a DefintionList
        definitions = model.definitions
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        begin
            definition = definitions.load path
        rescue
            UI.messagebox $!.message
        end
        behavior = definition.behavior
        status = behavior.always_face_camera?
        if (status)
            UI.messagebox status
        else
           UI.messagebox "Always Face Camera is equal to false"
        end
        # Returns
        behavior.always_face_camera = true
        
        begin
                s = behavior.shadows_face_sun?
        rescue
                UI.messagebox $!.message
        end
        if (s)
                UI.messagebox s
        else
                UI.messagebox "Failure"
        end




end

def snapToTest

        model = Sketchup.active_model
        # Returns a DefintionList
        definitions = model.definitions
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        begin
            definition = definitions.load path
        rescue
            UI.messagebox $!.message
        end
        behavior = definition.behavior
        # Returns a number 0=Arbitrary, 1=Horizontal, 2=Vertical, and 3=Sloped
        b = behavior.snapto
        if (b)
            UI.messagebox b
        else
            UI.messagebox "Failure: Is not a 2D Model"
        end
        begin
            behavior.snapto = SnapTo_Vertical
        rescue
            UI.messagebox $!.message
        end
        b = behavior.snapto
        if (b)
            UI.messagebox b
        else
            UI.messagebox "Failure"
        end
end



if( not file_loaded?("behaviortests.rb") )

    # This will add a separator to the menu, but only once
    add_separator_to_menu("Plugins")
    
    plugins_menu = UI.menu("Plugins")
    BehaviorTest_menu = plugins_menu.add_submenu("Behavior Tests")
    BehaviorTest_menu.add_item("Behavior.always_face_camera=") { alwaysFaceCameraEqualsTest }
    BehaviorTest_menu.add_item("Behavior.always_face_camera?") { alwaysFaceCameraTest }
    BehaviorTest_menu.add_item("Behavior.cuts_opening?_and_cuts_opening=") { cutsOpeningTest }
    BehaviorTest_menu.add_item("Behavior.is2d?_and_is2d=") { is2dTest }
    BehaviorTest_menu.add_item("Behavior.shadows_face_sun=") { shadowsFaceSunEqualsTest }
    BehaviorTest_menu.add_item("Behavior.shadows_face_sun?") { shadowsFaceSunTest }

    BehaviorTest_menu.add_item("Behavior.snapto_and_snapto=") { snapToTest }


end

#-----------------------------------------------------------------------------
file_loaded("behaviortests.rb")
