# Copyright 2005, @Last Software, Inc.

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------
def definitionCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        definition = instance.definition
        if (definition)
                name = definition.name
                UI.messagebox name
        else
                UI.messagebox "Failure"
        end
end


def definitionEqualsCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path1 = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        path2 = Sketchup.find_support_file "Office_Laptop.skp" ,"Components/Architecture_Sampler/"
        model = Sketchup.active_model
        definitions = model.definitions
        componentdefinition1 = definitions.load path1
        componentdefinition2 = definitions.load path2
        instance = entities.add_instance componentdefinition1, transform
        UI.messagebox "Added Bed"
        definition = instance.definition=componentdefinition2
        if (definition)
                name = definition.name
                UI.messagebox name
        else
                UI.messagebox "Failure"
        end

                

end

def explodeCITest

        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        # Status is an array of all of the entities, verticies, edges uses, and everything that makes up the component
        status = instance.explode
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end               
end

def lockedCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        status = instance.locked?
        UI.messagebox status
end

def gluedToCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        status = instance.glued_to
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Component Not Glued to Anything"
        end               

                

end

def gluedToEqualsCITest
        depth = 100
        width = 100
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        point = Geom::Point3d.new 10,10,0
        transform = Geom::Transformation.new point
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform

        begin
                status = instance.glued_to=face
        rescue
                UI.messagebox $!.message
        end
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end
        
end

def makeUniqueCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        # Returns unique component instance
        status = instance.make_unique
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end               

                

end

def moveCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        point2 = Geom::Point3d.new 30, 40, 50
        transform2 = Geom::Transformation.new point2
        UI.messagebox "Applying a new Transformation (in this case, a move)"
        status = instance.move! transform2
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end               
                        

end

def transformCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        point2 = Geom::Point3d.new 30, 40, 50
        transform2 = Geom::Transformation.new point2
        UI.messagebox "Applying a new Transformation (in this case, a move)"
        status = instance.transform! transform2
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end               
end

def transformationCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        transformation = instance.transformation
        if (transformation)
                UI.messagebox transformation
        else
                UI.messagebox "Failure"
        end               

                

end

def transformationEqualsCITest
        point = Geom::Point3d.new 10,20,30
        transform = Geom::Transformation.new point
        model = Sketchup.active_model
        entities = model.active_entities
        path = Sketchup.find_support_file "fan.skp" ,"Components/Architecture_Sampler/"
        definitions = model.definitions
        componentdefinition = definitions.load path
        instance = entities.add_instance componentdefinition, transform
        point2 = Geom::Point3d.new 30, 40, 50
        transform2 = Geom::Transformation.new point2
        UI.messagebox "Applying a new Transformation (in this case, a move)"
        status = instance.transformation=transform2
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end               
        
end

if( not file_loaded?("citests.rb") )

    # This will add a separator to the menu, but only once
    add_separator_to_menu("Plugins")
    
    plugins_menu = UI.menu("Plugins")
    ci_menu = plugins_menu.add_submenu("ComponentInstance Tests")
    ci_menu.add_item("ComponentInstance.definition") { definitionCITest }
    ci_menu.add_item("ComponentInstance.definition=") { definitionEqualsCITest }
    ci_menu.add_item("ComponentInstance.explode") { explodeCITest }
    ci_menu.add_item("ComponentInstance.glued_to") { gluedToCITest }
    ci_menu.add_item("ComponentInstance.glued_to=") { gluedToEqualsCITest }
    ci_menu.add_item("ComponentInstance.locked?") { lockedCITest }
    ci_menu.add_item("ComponentInstance.make_unique") { makeUniqueCITest }
    ci_menu.add_item("ComponentInstance.move!") { moveCITest }
    ci_menu.add_item("ComponentInstance.transform!") { transformCITest }
    ci_menu.add_item("ComponentInstance.transformation") { transformationCITest }
    ci_menu.add_item("ComponentInstance.transformation=") { transformationEqualsCITest }

end

#-----------------------------------------------------------------------------
file_loaded("citests.rb")
