# Copyright 2005, @Last Software, Inc.

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------

def allConnectedFaceTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        # I just happen to know that the second and third entities in the
        # entities objects are edges.
        entity1 = entities[0]
        entities = entity1.all_connected
        if (entities)
                UI.messagebox entities
        else
                UI.messagebox "Failure"
        end       

end

def areaFaceTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        area = face.area
        if (area)
                UI.messagebox area
        else
                UI.messagebox "Failure"
        end
end

def backMaterialFaceTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        back = face.back_material
        if (back)
                UI.messagebox back
        else
                UI.messagebox "Failure"
        end                

                
end

def backMaterialEqualsFaceTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        status = face.back_material="red"
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end                


end

def edgesFaceTest                
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        edges = face.edges
        if (edges)
                UI.messagebox edges
        else
                UI.messagebox "Failure"
        end
end

def followMeFaceTest
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        line = entities.add_line point1, point2
        begin
                status = face.followme line
        rescue
                UI.messagebox $!.message
        end
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end
end

def loopsFaceTest                
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        loops = face.loops
        if (loops)
                UI.messagebox loops
        else
                UI.messagebox "Failure"
        end

end

def meshFaceTest
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        mesh = face.mesh
        if (mesh)
                UI.messagebox mesh
        else
                UI.messagebox "Failure"
        end


end

def normalFaceTest                
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        normal = face.normal
        if (normal)
                UI.messagebox normal
        else
                UI.messagebox "Failure"
        end


end

def outerLoopFaceTest
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        loop = face.outer_loop
        if (loop)
                UI.messagebox loop
        else
                UI.messagebox "Failure"
        end


end

def planeFaceTest
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        plane = face.plane
        if (plane)
                UI.messagebox plane
        else
                UI.messagebox "Failure"
        end

end

def positionMaterialFaceTest


end

def pushpullFaceTest
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        status = face.pushpull 100, true
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end
end

def reverseFaceTest
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        status = face.reverse!
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end        
end

def verticesFaceTest
        point1 = Geom::Point3d.new (0,0,0)
        point2 = Geom::Point3d.new (0,0,100)
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        vertices = face.vertices
        if (vertices)
                UI.messagebox vertices
        else
                UI.messagebox "Failure"
        end


end


if( not file_loaded?("facetests.rb") )

    # This will add a separator to the menu, but only once
    add_separator_to_menu("Plugins")
    
    plugins_menu = UI.menu("Plugins")
    Face_menu = plugins_menu.add_submenu("Face Tests")
    Face_menu.add_item("Face.all_connected") { allConnectedFaceTest }
    Face_menu.add_item("Face.area") { areaFaceTest }
    Face_menu.add_item("Face.back_material") { backMaterialFaceTest }
    Face_menu.add_item("Face.back_material=") { backMaterialEqualsFaceTest }
    Face_menu.add_item("Face.edges") { edgesFaceTest }
    Face_menu.add_item("Face.followme") { followMeFaceTest }
    Face_menu.add_item("Face.loops") { loopsFaceTest }
    Face_menu.add_item("Face.mesh") { meshFaceTest }
    Face_menu.add_item("Face.normal") { normalFaceTest }
    Face_menu.add_item("Face.outer_loop") { outerLoopFaceTest }
    Face_menu.add_item("Face.plane") { planeFaceTest }
    Face_menu.add_item("Face.position_material") { positionMaterialFaceTest }
    Face_menu.add_item("Face.pushpull") { pushpullFaceTest }
    Face_menu.add_item("Face.reverse!") { reverseFaceTest }
    Face_menu.add_item("Face.vertices") { verticesFaceTest }
end

#-----------------------------------------------------------------------------
file_loaded("facetests.rb")
