# Copyright 2005, @Last Software, Inc.

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------
        
def newPolygonMeshTest

        mesh = Geom::PolygonMesh.new
        if (mesh)
                UI.messagebox mesh
        else
                UI.messagebox "Failure"
        end
end        


def addPointPolygonMeshTest
        mesh = Geom::PolygonMesh.new
        point = Geom::Point3d.new 0,1,2
        index = mesh.add_point point
        if (index)
                UI.messagebox index
        else
                UI.messagebox "Failure"
        end


end

def addPolygonPolygonMeshTest
        mesh = Geom::PolygonMesh.new
        point = Geom::Point3d.new 0,1,2
        point1 = Geom::Point3d.new 1,0,2
        point2 = Geom::Point3d.new 2,0,1
        begin                       
                status = mesh.add_polygon point, point1, point2
        rescue
                UI.messagebox $!.message
        end      
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end
end

def countPointsPolygonMeshTest
        mesh = Geom::PolygonMesh.new
        point = Geom::Point3d.new 0,1,2
        index = mesh.add_point point
        num = mesh.count_points
        if (num)
                UI.messagebox num
        else
                UI.messagebox "Failure"
        end
end

def countPolygonsPolygonMeshTest
        mesh = Geom::PolygonMesh.new
        point = Geom::Point3d.new 0,1,2
        point1 = Geom::Point3d.new 1,0,2
        point2 = Geom::Point3d.new 2,0,1
	index = mesh.add_polygon point, point1, point2
	nump = mesh.count_polygons
	if (nump)
		UI.messagebox nump
	else
		UI.messagebox "Failure"
	end
end

def normalAtPolygonMeshTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts


        mesh= face.mesh(7)
        normal = mesh.normal_at 1
        UI.messagebox normal
end

def pointAtPolygonMeshTest
        mesh = Geom::PolygonMesh.new
        point1 = Geom::Point3d.new 0,1,2
        point2 = Geom::Point3d.new 10,20,30
        index = mesh.add_point point1
        index = mesh.add_point point2
        begin
                # returns a point
                point = mesh.point_at 1
        rescue
                UI.messagebox $!.message
        end
        
        if (point)
                UI.messagebox point
        else
                UI.messagebox "Failure"
        end
end

def pointIndexPolygonMeshTest
        mesh = Geom::PolygonMesh.new
        point1 = Geom::Point3d.new 0,1,2
        point2 = Geom::Point3d.new 10,20,30
        index = mesh.add_point point1
        index = mesh.add_point point2
        index = mesh.point_index point1
        # returns 1
        if (index)
                UI.messagebox index
        else
                UI.messagebox "Failure"
        end

end

def pointsPolygonMeshTest
        mesh = Geom::PolygonMesh.new
        point1 = Geom::Point3d.new 0,1,2
        point2 = Geom::Point3d.new 10,20,30
        index = mesh.add_point point1
        index = mesh.add_point point2
        # returns array of points in the mesh
        num = mesh.points
        if (num)
                UI.messagebox num
        else
                UI.messagebox "Failure"
        end
end

def polygonAtPolygonMeshTest
	mesh = Geom::PolygonMesh.new
        point = Geom::Point3d.new 0,1,2
        point1 = Geom::Point3d.new 1,0,2
        point2 = Geom::Point3d.new 2,0,1
	status = mesh.add_polygon point, point1, point2
	polygon = mesh.polygon_at 1
	if (polygon)
		UI.messagebox polygon
	else
		UI.messagebox "Failure"
	end
end

def polygonPointsAtPolygonMeshTest
	mesh = Geom::PolygonMesh.new
        point = Geom::Point3d.new 0,1,2
        point1 = Geom::Point3d.new 1,0,2
        point2 = Geom::Point3d.new 2,0,1
	status = mesh.add_polygon point, point1, point2
	points = mesh.polygon_points_at 1
	if (points)
		UI.messagebox points
	else
		UI.messagebox "Failure"
	end
end

def polygonsPolygonMeshTest
	mesh = Geom::PolygonMesh.new
        point = Geom::Point3d.new 0,1,2
        point1 = Geom::Point3d.new 1,0,2
        point2 = Geom::Point3d.new 2,0,1
	status = mesh.add_polygon point, point1, point2
	polygons = mesh.polygons
	if (polygons)
		UI.messagebox polygons
	else
		UI.messagebox "Failure"
	end
end

def setPointPolygonMeshTest
# Set an existing point to another point
        mesh = Geom::PolygonMesh.new
        point1 = Geom::Point3d.new 0,1,2
        point2 = Geom::Point3d.new 10,20,30
        index = mesh.add_point point1
        begin
                status = mesh.set_point 1, point2
        rescue
                UI.messagebox $!.message
        end
        # returns the polygon mesh
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end


end

def transformPolygonMeshTest
        point = Geom::Point3d.new 100,200,300
        t = Geom::Transformation.new point
        mesh = Geom::PolygonMesh.new
        point1 = Geom::Point3d.new 0,1,2
        index = mesh.add_point point1
        begin
                status = mesh.transform! t
        rescue
                UI.messagebox $!.message
        end
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end

end


def uvAtPolygonMeshTest

        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        
        mesh= face.mesh(7)
        point = mesh.uv_at(1,1)
        UI.messagebox point
end

def uvsPolygonMeshTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts


        mesh= face.mesh(7)
        uvs = mesh.uvs 1
        UI.messagebox uvs
end



if( not file_loaded?("polygonmeshtests.rb") )

    # This will add a separator to the menu, but only once
    add_separator_to_menu("Plugins")    
    plugins_menu = UI.menu("Plugins")
    PolygonMesh_menu = plugins_menu.add_submenu("PolygonMesh Tests")
    PolygonMesh_menu.add_item("PolygonMesh.new") { newPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.add_point") { addPointPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.add_polygon") { addPolygonPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.count_points") { countPointsPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.count_polygons") { countPolygonsPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.normal_at") { normalAtPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.point_at") { pointAtPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.point_index") { pointIndexPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.points") { pointsPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.polygon_at") { polygonAtPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.polygon_points_at") { polygonPointsAtPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.polygons") { polygonsPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.set_point") { setPointPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.transform!") { transformPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.uv_at") { uvAtPolygonMeshTest }
    PolygonMesh_menu.add_item("PolygonMesh.uvs") { uvsPolygonMeshTest }
end
#-----------------------------------------------------------------------------
file_loaded("polygonmeshtests.rb")
       
       
       

