# Copyright 2005, @Last Software, Inc.

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------
        
def getSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        entity = selection[0]
        if (entity)
                UI.messagebox entity
        else
                UI.messagebox "Failure"
        end
end

def addSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        # status is the number of entities added to the selection
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end
end

def atSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        # looks like you have to retrieve from the selection set starting
        # at zero.
        entity = selection.at(0)
        if (entity)
                UI.messagebox entity
        else
                UI.messagebox "Failure"
        end



end

def clearSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        UI.messagebox "Ready to Clear"
        # returns nil
        status = selection.clear
        UI.messagebox status
end

def containsSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        status = selection.contains? entity
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end
end

def countSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        number = selection.count
        if (number)
                UI.messagebox number
        else
                UI.messagebox "Failure"
        end
end

def eachSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        selection.each { | entity| UI.messagebox entity }

end

def emptySelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        status = selection.empty?
        if (status)
                UI.messagebox status
        else
                UI.messagebox status
        end
end

def firstSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        entity = selection.first
        if (entity)
                UI.messagebox entity
        else
                UI.messagebox "Failure"
        end
end

def includeSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        status = selection.include? entity
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end

end

def isCurveSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        status = selection.is_curve?
        if (status)
                UI.messagebox status
        else
                # False
                UI.messagebox status
        end
end

def isSurfaceSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[4]
        status = selection.add entity
        status = selection.is_surface?
        if (status)
                UI.messagebox status
        else
                # False
                UI.messagebox status
        end


end

def lengthSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        number = selection.length
        if (number)
                UI.messagebox number
        else
                UI.messagebox "Failure"
        end
end

def modelSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        status = selection.model
        if (status)
                UI.messagebox status
        else
              
                UI.messagebox "Failure"
        end
end

def nitemsSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        number = selection.nitems
        if (number)
                UI.messagebox number
        else
                UI.messagebox "Failure"
        end
end

def removeSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        UI.messagebox "Ready to remove item from selection set"
        # returns number of items removed
        status = selection.remove entity
        
        if (status)
                UI.messagebox status
        else
                UI.messagebox status
        end
end

def shiftSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        UI.messagebox "Ready to remove item from selection set"
        entity = selection.shift
        if (entity)
                UI.messagebox entity
        else
                UI.messagebox "Failure"
        end
end

def singleObjectSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        status = selection.single_object?
        # True if one entity, false if 0 or more than 1
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end
end

def toggleSelectionTest
        depth = 100
        width = 100
        model = Sketchup.active_model
        entities = model.active_entities
        pts = []
        pts[0] = [0, 0, 0]
        pts[1] = [width, 0, 0]
        pts[2] = [width, depth, 0]
        pts[3] = [0, depth, 0]
        # Add the face to the entities in the model
        face = entities.add_face pts
        selection = model.selection
        entity = entities[0]
        status = selection.add entity
        UI.messagebox "Ready to toggle item in selection set"
        status = selection.toggle entity
        # Status is number of items toggled
        if (status)
                UI.messagebox status
        else
                UI.messagebox "Failure"
        end
end


if( not file_loaded?("selectiontests.rb") )

    # This will add a separator to the menu, but only once
    add_separator_to_menu("Plugins")    
    plugins_menu = UI.menu("Plugins")
    Selection_menu = plugins_menu.add_submenu("Selection Tests")
    Selection_menu.add_item("Selection []") { getSelectionTest }
    Selection_menu.add_item("Selection.add") { addSelectionTest }
    Selection_menu.add_item("Selection.at") { atSelectionTest }
    Selection_menu.add_item("Selection.clear") { clearSelectionTest }
    Selection_menu.add_item("Selection.contains") { containsSelectionTest }
    Selection_menu.add_item("Selection.count") { countSelectionTest }
    Selection_menu.add_item("Selection.each") { eachSelectionTest }
    Selection_menu.add_item("Selection.empty?") { emptySelectionTest }
    Selection_menu.add_item("Selection.first") { firstSelectionTest }
    Selection_menu.add_item("Selection.include?") { includeSelectionTest }
    Selection_menu.add_item("Selection.is_curve?") { isCurveSelectionTest }
    Selection_menu.add_item("Selection.is_surface?") { isSurfaceSelectionTest }
    Selection_menu.add_item("Selection.length") { lengthSelectionTest }
    Selection_menu.add_item("Selection.model") { modelSelectionTest }
    Selection_menu.add_item("Selection.nitems") { nitemsSelectionTest }
    Selection_menu.add_item("Selection.remove") { removeSelectionTest }
    Selection_menu.add_item("Selection.shift") { shiftSelectionTest }
    Selection_menu.add_item("Selection.single_object?") { singleObjectSelectionTest }
    Selection_menu.add_item("Selection.toggle") { toggleSelectionTest }

end

#-----------------------------------------------------------------------------
file_loaded("selectiontests.rb")
       
       
       

